unit Main;

{$mode objfpc}{$H+}

interface

uses
  Classes, ComCtrls, ExtCtrls, SysUtils, FileUtil, Forms,
  Controls, Graphics, Dialogs, TAGraph, TASeries, TASources, TATools,
  TATransformations, TACustomSeries, TAIntervalSources;

type

  { TForm1 }

  TForm1 = class(TForm)
    DateTimeIntervalChartSource1: TDateTimeIntervalChartSource;
    catOscillatorLinearAxisTransform1: TLinearAxisTransform;
    catOscillator: TChartAxisTransformations;
    ChartToolset1: TChartToolset;
    ChartToolset1DataPointDragTool1: TDataPointDragTool;
    ChartToolset1PanDragTool1: TPanDragTool;
    ChartToolset1ZoomDragTool1: TZoomDragTool;
    chOscillator: TChart;
    chOscillatorLineSeries1: TLineSeries;
    lcsOscillator: TListChartSource;
    PageControl1: TPageControl;
    RandomChartSource1: TRandomChartSource;
    tsOscilloscope: TTabSheet;
    tsOwnerDrawnPointer: TTabSheet;
    timOscilloscope: TTimer;
    procedure DateTimeIntervalChartSource1DateTimeStepChange(Sender: TObject;
      ASteps: TDateTimeStep);
    procedure FormCreate(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure timOscilloscopeTimer(Sender: TObject);
  private
    FStartTime: TDateTime;
  end;

var
  Form1: TForm1; 

implementation

{$R *.lfm}

uses
  LCLIntf, IntfGraphics, TAChartUtils, TAChartAxisUtils;


{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  DateTimeIntervalChartSource1.Params.MaxLength := 120;   // Größerer Abstand zwischen den Labels
  DateTimeIntervalChartSource1.SuppressPrevUnit := false;
  DateTimeIntervalChartSource1.DateTimeStepFormat.MilliSecondFormat := 's.zzz';

  chOscillator.BottomAxis.Marks.Source := DateTimeIntervalChartSource1;
  chOscillator.BottomAxis.Marks.Style := smsLabel;
  chOscillator.BottomAxis.Title.Caption := 'Verstrichene Zeit';
  chOscillator.BottomAxis.Title.Visible := true;

  // Die rechte Seite des Chart zappelt hinundher, wenn das letzte x-Label über den
  // Rand hinausragt. Das kann man mit einer rechten Achsen verhindert, für die
  // man etwas Platz reserviert. Kannst ja mal den folgenden "with"-Block
  // auskommentieren, um den Unterschied zu sehen.
  with chOscillator.AxisList.Add do
  begin
    Alignment := calRight;
    Title.Caption := ' ';
    Title.Visible := true;
    Marks.Visible := false;
    LabelSize := 20;
  end;

  //DateTimeIntervalChartSource1.DateTimeFormat := 'hh:mm';
  {with chOscillator.BottomAxis do begin     {BottomAxis und AxisList[1] ist das Gleiche}
  //with Chart1.AxisList[1] do begin
    Marks.Source := DateTimeIntervalChartSource1;
    Marks.Style := smsLabel;  {diese Zeile erzeugt einen "Error: Illegal Expression",}
    Range.Min:=0;          {deshalb im Objektinspektor Marks.Style auf smsLabel setzen}
    Range.Max:=1;          {0 bis 1 entspricht ein Tag}
    Range.UseMin:=True;
    Range.UseMax:=True;
  end;}

  PageControl1Change(Sender);
end;

procedure TForm1.DateTimeIntervalChartSource1DateTimeStepChange(
  Sender: TObject; ASteps: TDateTimeStep);
var
  s: String;
begin
  case ASteps of
    dtsMillisecond: s := ' (Sek)';
    dtsSecond: s := ' (Min:Sek)';
    dtsMinute: s := ' (Std:Min)';
    dtsHour: s := ' (Tag Std:Min)';
    else s := '';
  end;

  // Achsenbeschriftung anpassen - ist besser verständlich...
  // Aber Achtung: gelegentlich kommt es zu einem rekursiven Aufruf, der nicht
  // endet --> Verhindern durch Disable/EnableRedrawing
  chOscillator.DisableRedrawing;
  chOscillator.BottomAxis.Title.Caption := 'Verstrichene Zeit' + s;
  chOscillator.EnableRedrawing;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  timOscilloscope.Enabled := PageControl1.ActivePage = tsOscilloscope;
  FStartTime := Now;
end;

procedure TForm1.timOscilloscopeTimer(Sender: TObject);
var
  //rp: TChartRenderingParams;
  t: TDateTime;
begin
  //rp := chOscillator.RenderingParams;

  with chOscillatorLineSeries1 do begin
    WriteLn(Count);
    t := Now - FStartTime;
    AddXY(t, Sin((GetXMax / 20 ) * (24*60*60)) + Random - 0.5);
    //    Add(Sin(GetXMax / 20) + Random - 0.5);
    if Count > 20 then
      ListSource.Delete(0);
    // Allow to zoom into various parts of the chart
    // while preserving "oscilloscope" behaviour.

    // wp: Ich würde das eher ausschalten, denn wenn ich in einen Bereich hineinzoome,
    // dann möchte ich nicht, dass dieser wieder aus dem sichtbaren Fenster rausläuft.
    // Und damit braucht man auch die Variable rp nicht mehr.

    //catOscillatorLinearAxisTransform1.Offset := -GetXMin;
  end;

  // Transformation change resets logical extent.
  // We know the old extent is safe to keep, so restore it.
  //chOscillator.RenderingParams := rp;
end;

end.

